﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using Syncfusion.EJ.Export;
using Syncfusion.XlsIO;
using Newtonsoft.Json;
using Syncfusion.JavaScript;
using MvcApplication66.models;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index(){
            ViewBag.datasource = new NorthwindDataContext().EmployeeViews.ToList();
            return View();
        }
        public ActionResult DataSource(DataManager dm)
        {
            int key = 0;
            var DataSource = OrderRepository.GetAllRecords();
            DataOperations op = new DataOperations();
            if (dm.Where != null)
            {
                key = int.Parse(dm.Where[0].value.ToString());
                DataSource = DataSource.Where(emp => emp.EmployeeID == key).ToList();
            }
            DataResult result = new DataResult();
            if (dm.Skip != 0 || dm.Take != 0)
                result.result = DataSource.Skip(dm.Skip).Take(dm.Take).ToList();
            else result.result = DataSource;
            result.count = DataSource.Count();
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Update(EditableOrder value)
        {
            OrderRepository.Update(value);
            var data = OrderRepository.GetAllRecords();
            return Json(value, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Insert(EditableOrder value)
        {
            OrderRepository.Add(value);
            var data = OrderRepository.GetAllRecords();
            return Json(value, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Delete(int key)
        {
            OrderRepository.Delete(key);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
    }
}